﻿using FliUtils.Mvvm;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FliProCameraLib
{
    public class FliProSensorSettings : ObservableProperties
    {

        //**************************************************************
        #region Constructor and Initialization

        public FliProSensorSettings()
        {
        }

        #endregion Constructor and Initialization

        //**************************************************************
        #region Public Types

        public enum Binning_Enum
        {
            binning_1_1,
            binning_2_2,
            binning_2_4
        }

        public enum Gain_Enum
        {
            gain_0_66,
            gain_1_85,
            gain_2_49,
            gain_3_68,
            gain_1_29,
            gain_3_70,
            gain_4_95,
            gain_7_25
        }

        public enum Pixel_Depth
        {
            pixelDepth_12,
            pixelDepth_10
        }

        public enum Sensor_Modes
        {
            rolling_LDR,
            rolling_HDR,
            global_HDR
        }

        #endregion Public Types

        //**************************************************************
        #region Observable Properties

        /// <summary>
        /// The binning value
        /// </summary>
        public Binning_Enum BinningEnum
        {
            get { return _BinningEnum; }
            set
            {
                SetValue(ref _BinningEnum, value);
            }
        }
        private Binning_Enum _BinningEnum = Binning_Enum.binning_1_1;

        /// <summary>
        /// The Black Level Adjust Value
        /// </summary>
        //public int BlackLevelAdjustValue
        //{
        //    get { return _BlackLevelAdjustValue; }
        //    set
        //    {
        //        SetValue(ref _BlackLevelAdjustValue, value);
        //    }
        //}
        //private int _BlackLevelAdjustValue = 0;

        ///// <summary>
        ///// The Black Level Sun Value
        ///// </summary>
        //public int BlackLevelSunValue
        //{
        //    get { return _BlackLevelSunValue; }
        //    set
        //    {
        //        SetValue(ref _BlackLevelSunValue, value);
        //    }
        //}
        //private int _BlackLevelSunValue = 0;

        /// <summary>
        /// The gain value
        /// </summary>
        public Gain_Enum GainEnum
        {
            get { return _GainEnum; }
            set
            {
                SetValue(ref _GainEnum, value);
            }
        }
        private Gain_Enum _GainEnum = Gain_Enum.gain_0_66;

        /// <summary>
        /// The pixel depth
        /// </summary>
        public Pixel_Depth PixelDepthEnum
        {
            get { return _PixelDepthEnum; }
            set
            {
                SetValue(ref _PixelDepthEnum, value);
            }
        }
        private Pixel_Depth _PixelDepthEnum = Pixel_Depth.pixelDepth_12;

        #endregion Observable Properties

    }
}
